import es, cfglib, gamethread, os

config = cfglib.AddonCFG(es.getAddonPath("dodgeball") + "/dodgeball.cfg")
config.text("**************************")
config.text("   Downloads and Models   ")
config.text("**************************")
dodgeball_disable_downloads = config.cvar("dodgeball_disable_downloads",   0, "Change to 1 if you are using fast downloads or mani")
dodgeball_radio = config.cvar("dodgeball_radio",   '!enable', "Disable/enable fire in hole sound")

config.write()

model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'models/props/slow/dodgeball/'
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/props/slow/dodgeball/'

info = es.AddonInfo()
info.name     = "DodgeBall"
info.version  = "1.9"
info.url      = "None"
info.basename = "sic_dodgeball"
info.author   = "sicman_adrian"
es.ServerVar('sic_dodgeball', info.version, info.name).makepublic()

def load():
    es.addons.registerTickListener(setModel)
    es.doblock('corelib/noisy_on')
    config.execute()
    if not es.ServerVar("eventscripts_currentmap") == "":
        precacheModels()
        if dodgeball_disable_downloads == 0:
            downloadskins()
    if not es.exists('saycommand', str(dodgeball_radio)):
        es.regsaycmd(str(dodgeball_radio), 'dodgeball/radio')

def unload():
    es.addons.unregisterTickListener(setModel)
    es.doblock('corelib/noisy_off')
    if es.exists('saycommand', dodgeball_radio):
        es.unregsaycmd(dodgeball_radio)

def es_map_start(ev):
    precacheModels()
    if dodgeball_disable_downloads == 0:
        downloadskins()

def downloadskins():
    for dlfile in os.listdir(model_folder1):
        es.stringtable('downloadables', model_folder1 + dlfile)
    for dlfile_m in os.listdir(material_folder1):
        es.stringtable('downloadables', material_folder1 + dlfile_m)
    es.stringtable('downloadables', 'sound/dodgeball/dodgeballis.mp3')

def precacheModels():
    global dodgeball_model
    dodgeball_model = es.precachemodel('models/props/slow/dodgeball/slow.mdl')

def setModel():
    for i in es.createentitylist('flashbang_projectile'):
        es.setindexprop(i, 'CBaseEntity.m_nModelIndex', dodgeball_model)
        es.setindexprop(i, 'CBaseEntity.m_clrRender', -1)

def grenade_bounce(ev):
    es.server.queuecmd("es_fire %s flashbang_projectile kill" % ev['userid'])

def weapon_fire(ev):
    userid = ev['userid']
    alive = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
    if ev['weapon'] == 'flashbang':
         if not alive:
            gamethread.delayed(0.8, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)

def player_spawn(ev):
    userid = ev['userid']
    alive = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
    if ev['es_userteam'] >= '2':
        if not alive:
            es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)
            es.setplayerprop(userid, "CBasePlayer.m_iHealth", 1)
''''
def player_hurt(ev):
    userid = ev['userid']
    if ev['weapon'] == 'flashbang':
        es.server.queuecmd('damage %s 99 2 %s'%(ev['userid'], ev['attacker']))
'''

def player_activate(ev):
    es.cexec(ev['userid'], 'play dodgeball/dodgeballis.mp3')
    es.cexec(ev['userid'], 'ignorerad')

def radio():
    userid = es.getcmduserid()
    es.cexec(userid, 'ignorerad')

def player_blind(ev):
    es.setplayerprop(ev['userid'], 'CCSPlayer.m_flFlashMaxAlpha', 0)

def round_start(ev):
    userid = es.getuserid()
    if userid:
        es.server.queuecmd('es_xfire %s func_hostage_rescue kill'% userid)
        es.server.queuecmd('es_xfire %s hostage_entity kill'% userid)
        es.server.queuecmd('es_xfire %s func_bomb_target kill'% userid)
        es.server.queuecmd('es_xfire %s func_buyzone kill'% userid)
    entlist = es.createentitylist()
    for index in entlist:
       if entlist[index]['classname'].startswith('weapon_') and es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
          es.server.queuecmd('es_xremove %s' % index)

def player_death(ev):
    entlist = es.createentitylist()
    for index in entlist:
       if entlist[index]['classname'].startswith('weapon_') and es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
          es.server.queuecmd('es_xremove %s' % index)